import numpy as np
import re
from matplotlib.backends.backend_pdf import PdfPages
import matplotlib

f = open('outputBenchmark')

mode = ''
data = {}
index = 0
for line in f:
  l = line.strip()
   
  result = re.match('(\d+) checks', l)
  if l=='SIMPLE' or l=='SE' or l=='TP' or l=='NOEFFS' or l=='BYTES' or l=='BYTESNOBLAME':
    mode = l
    data[mode] = {}
  elif result:
    index = int(result.groups()[0])*1000000
    data[mode][index] = []
  else:
    data[mode][index] += [float(l)]
    

def std(l):
  np.array([l])
  return np.std(l)

def avg(l):
  np.array([l])
  return np.average(l)

case = 'SIMPLE'

import matplotlib.pyplot as plt
avgNOEFFS = sorted(map(lambda l: (avg(data["NOEFFS"][l])), data["NOEFFS"]))
def graph(case, color, linestyle, marker = ''):
  lbls = sorted(map(lambda l: l, data[case]))
  stdA = sorted(map(lambda l: (std(data[case][l])), data[case]))
  avgA = sorted(map(lambda l: (avg(data[case][l])), data[case]))
  print case
  print lbls
  print avgA


  #print "basic ovehead:"+str(avgA[0]/avgNOEFFS[0]*100 - 100)
  print "overhead" + str(map(lambda l: l/avgNOEFFS[0]*100 -100, avgA))


  print "times" + str(" & ".join(map(lambda l: "{:.0f}".format(l/avgNOEFFS[0]), avgA)))

  l = []
  for i in range(0,len(avgA)):
    l += [str("{:.3f}".format(avgA[i]))+" & "+str("{:.3f}".format(stdA[i]))+" & "+"{:.3f}x".format(avgA[i]/avgNOEFFS[0])]
  print " & ".join(l)

  #print "avg" + str(" & ".join(map(lambda l: "{:.3f}".format(l), avgA)))
  #print "std" + str(" & ".join(map(lambda l: "{:.3f}".format(l), stdA)))

  lblsAll = map(lambda l: map(lambda x: l, data[case][l]), data[case])
  valuesAll = map(lambda l: map(lambda x: x, data[case][l]), data[case])
  lblsAllFlatten = [item for sublist in lblsAll for item in sublist]
  valuesAllFlatten = [item for sublist in valuesAll for item in sublist]
  plt.errorbar(lbls, avgA,color=color,yerr=stdA, linestyle=linestyle, linewidth=3, marker=marker, markersize=10)

graph('SIMPLE', '#004358', '-')
graph('SE', '#BEDB39', '--')
graph('TP', '#FD7400', ':')



def plotSimple(case, style):
  lbls = map(lambda l: l, data[case])
  avgA = map(lambda l: (avg(data[case][l])), data[case])
  stdA = map(lambda l: (std(data[case][l])), data[case])
  plt.plot(lbls, avgA,style)
  print case
  print "avgA", avgA
  print "stdA", stdA


graph('BYTES', 'red', '-', 'x')
plotSimple("NOEFFS", 'yo')



#line1 = plt.errorbar(lbls, avgA, yerr=stdA, label='2M reps')

plt.legend(['default', 'subeffecting', 'type params', 'bit vectors', 'no effects'], 2)

#plt.plot(lblsAll, valuesAll, 'ro')
plt.yscale('log')

axis = [plt.axis()[0], plt.axis()[1], plt.axis()[2], plt.axis()[3]]
axis[0] = axis[0]-axis[1]*0.1
axis[1] = axis[1]*1.1
axis[2] = axis[2]*2
axis[3] = axis[3]*1.5

plt.yticks([1, 5, 10, 25, 100], [1, 5, 10,  25, 100])

#plt.yticks((np.arange(1, 100, 5)))
#plt.grid(axis='y', linestyle='-')

#axis = [-1]+lbls+[lbls[-1]+1]

plt.axis(axis)


plt.ylabel('Seconds')
plt.xlabel('Number of run-time checks')


#plt.show()

pp = PdfPages('benchmark.pdf')
pp.savefig()
pp.close()
